TechDraw ProjectionGroup/ru: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(5 intermediate revisions by the same user not shown)
Line 1: Line 1:
<languages/>
<languages/>

{{Docnav/ru
{{Docnav/ru
|[[TechDraw_ActiveView/ru|Вставить активный вид (3D Вид)]]
|[[TechDraw_ActiveView/ru|Вставить активный вид (3D Вид)]]
Line 9: Line 10:
}}
}}


<div class="mw-translate-fuzzy">
{{GuiCommand/ru
{{GuiCommand/ru
|Name/ru=Вставить группу проекций
|Name/ru=Вставить группу проекций
Line 16: Line 18:
|SeeAlso=[[TechDraw_View/ru|Вставить Вид]], [[TechDraw_SectionView/ru|Вставить Вид сечения]]
|SeeAlso=[[TechDraw_View/ru|Вставить Вид]], [[TechDraw_SectionView/ru|Вставить Вид сечения]]
}}
}}
</div>


<span id="Description"></span>
==Описание==
==Описание==


The [[Image:TechDraw ProjectionGroup.svg|24px]] [[TechDraw_ProjectionGroup|ProjectionGroup]] tool creates a [https://en.wikipedia.org/wiki/Multiview_projection multiview projection] of one or more 3D objects. The isometric views of the 4 front corners can also be included.
The '''TechDraw ProjectionGroup''' tool creates a [https://en.wikipedia.org/wiki/Multiview_projection multiview projection] of one or more 3D objects. The isometric views of the 4 front corners can also be included.


If you only want to produce a single view, there is no advantage in using ProjectionGroup; you should then use [[TechDraw_View|Insert View]] instead. If you do not wish to use the traditional [https://en.wikipedia.org/wiki/Multiview_orthographic_projection#First-angle_projection first-] / [https://en.wikipedia.org/wiki/Multiview_orthographic_projection#Third-angle_projection third-angle projection], you should use multiple ''Views'' ([[TechDraw_View|Insert View]]) instead of ''ProjectionGroup''.
If you only want to produce a single view, there is no advantage in using ProjectionGroup; you should then use [[TechDraw_View|Insert View]] instead. If you do not wish to use the traditional [https://en.wikipedia.org/wiki/Multiview_orthographic_projection#First-angle_projection first-] / [https://en.wikipedia.org/wiki/Multiview_orthographic_projection#Third-angle_projection third-angle projection], you should use multiple ''Views'' ([[TechDraw_View|Insert View]]) instead of ''ProjectionGroup''.
Line 26: Line 30:
{{Caption|Three orthogonal views and one isometric view of a solid object}}
{{Caption|Three orthogonal views and one isometric view of a solid object}}


<span id="Usage"></span>
==Применение==
==Применение==


# Optionally rotate the [[3D_view|3D view]]. The camera direction in the [[3D_view|3D view]] determines the initial value of the {{MenuCommand|Primary Direction}} of the Projection Group (the {{PropertyData|Direction}} property of the central view).
# Optionally rotate the [[3D_view|3D view]]. The camera direction in the [[3D_view|3D view]] determines the initial value of the {{MenuCommand|Primary Direction}} of the Projection Group (the {{PropertyData|Direction}} property of the central view).
# Select one or more objects in the [[3D_view|3D view]] or [[Tree_view|Tree view]].
# Select one or more objects in the [[3D_view|3D view]] or [[Tree_view|Tree view]].
# If there are multiple drawing pages in the document: optionally add the desired page to the selection by selecting it in the [[Tree_view|Tree view]]. This is not optional for {{VersionMinus|0.19}}.
# If there are multiple drawing pages in the document: optionally add the desired page to the selection by selecting it in the [[Tree_view|Tree view]].
# There are several ways to invoke the tool:
# There are several ways to invoke the tool:
#* Press the {{Button|[[Image:TechDraw_ProjectionGroup.svg|16px]] [[TechDraw_ProjectionGroup|Insert Projection Group]]}} button.
#* Press the {{Button|[[Image:TechDraw_ProjectionGroup.svg|16px]] [[TechDraw_ProjectionGroup|Insert Projection Group]]}} button.
#* Select the {{MenuCommand|TechDraw → [[Image:TechDraw_ProjectionGroup.svg|16px]] Insert Projection Group}} option from the menu.
#* Select the {{MenuCommand|TechDraw → TechDraw Views → [[Image:TechDraw_ProjectionGroup.svg|16px]] Insert Projection Group}} option from the menu.
# If there are multiple drawing pages in the document and you have not yet selected a page, the {{MenuCommand|Page Chooser}} dialog box opens: {{Version|0.20}}
# If there are multiple drawing pages in the document and you have not yet selected a page, the {{MenuCommand|Page Chooser}} dialog box opens: {{Version|0.20}}
## Select the desired page.
## Select the desired page.
Line 46: Line 51:
{{Caption|Projection Group [[Task_panel|task panel]]. The Primary Direction field indicates the current view direction.}}
{{Caption|Projection Group [[Task_panel|task panel]]. The Primary Direction field indicates the current view direction.}}


<span id="Properties"></span>
==Свойства==
==Свойства==


Line 53: Line 59:


* {{PropertyData|Source|LinkList}}: Links to the drawable objects to be depicted.
* {{PropertyData|Source|LinkList}}: Links to the drawable objects to be depicted.
* {{PropertyData|XSource|XLinkList}}: Links to the drawable objects in an external file. {{Version|0.19}}
* {{PropertyData|XSource|XLinkList}}: Links to the drawable objects in an external file.
* {{PropertyData|Anchor|Link}}: The central view in the group. Normally the Front view.
* {{PropertyData|Anchor|Link}}: The central view in the group. Normally the Front view.
* {{PropertyData|ProjectionType|Enumeration}}: {{Value|First Angle}} or {{Value|Third Angle}}.
* {{PropertyData|ProjectionType|Enumeration}}: {{Value|First Angle}} or {{Value|Third Angle}}.
Line 85: Line 91:
Note that the central box displays the current projection direction of the primary view. It cannot be used to change the direction.
Note that the central box displays the current projection direction of the primary view. It cannot be used to change the direction.


<span id="Scripting"></span>
==Программирование==
==Программирование==


{{Emphasis|См. так же:}} [[TechDraw_API/ru|TechDraw API]] и [[FreeCAD_Scripting_Basics/ru|Основы составления скриптов FreeCAD]].
{{Emphasis|См. так же:}} [[TechDraw_API/ru|TechDraw API]] и [[FreeCAD_Scripting_Basics/ru|Основы составления скриптов FreeCAD]].


The NewProjGroup tool can be used in [[Macros|macros]] and from the [[Python|Python]] console. A full script is available in the Source distribution in "source-dir/src/Mod/TechDraw/TDTest/DProjGroupTest.py".
A Projection Group can be created with [[Macros|macros]] and from the [[Python|Python]] console by using the following functions:


{{Code|code=
{{Code|code=
import FreeCAD as App
#make a page

print("making a page")
page = FreeCAD.ActiveDocument.addObject('TechDraw::DrawPage','Page')
doc = App.ActiveDocument
FreeCAD.ActiveDocument.addObject('TechDraw::DrawSVGTemplate','Template')
cyl = doc.addObject("Part::Cylinder", "Cylinder")
doc.recompute()
FreeCAD.ActiveDocument.Template.Template = templateFileSpec

FreeCAD.ActiveDocument.Page.Template = FreeCAD.ActiveDocument.Template
page = doc.addObject("TechDraw::DrawPage", "Page")
template = doc.addObject("TechDraw::DrawSVGTemplate", "Template")
template.Template = App.getResourceDir() + "Mod/TechDraw/Templates/A4_LandscapeTD.svg"
page.Template = template


# Toggle the visibility of the page to ensure its width and height are updated (hack):
#make projection group
page.Visibility = False
group = FreeCAD.ActiveDocument.addObject('TechDraw::DrawProjGroup','ProjGroup')
page.Visibility = True
rc = page.addView(group)
group.Source = [fusion]


group = doc.addObject("TechDraw::DrawProjGroup", "ProjGroup")
#add Front(Anchor) view
page.addView(group)
frontView = group.addProjection("Front") ##need an Anchor
group.Source = [cyl]
group.ProjectionType = "Third Angle"


front_view = group.addProjection("Front") # First projection will become the Anchor.
#update group
group.Anchor.Direction = FreeCAD.Vector(0,0,1)
group.Anchor.Direction = (0, 1, 0)
group.Anchor.RotationVector = FreeCAD.Vector(1,0,0)
group.Anchor.RotationVector = (1, 0, 0)


left_view = group.addProjection("Left")
#add more projections
leftView = group.addProjection("Left")
top_view = group.addProjection("Top")
topView = group.addProjection("Top")
rightView = group.addProjection("Right")
rearView = group.addProjection("Rear")
BottomView = group.addProjection("Bottom")


group.X = page.PageWidth / 2
#remove a view from projection group
group.Y = page.PageHeight / 2
iv = group.removeProjection("Left")


doc.recompute()
}}
}}


Programming note: The Projection Group should always be added to the Page (ex. page.addView(group) before adding projections to the Group. This allows the Projection Group to use default parameter values derived from the parent page.
Note: The Projection Group should always be added to the Page, {{Incode|page.addView(group)}}, before adding projections to the Group. This allows the Projection Group to use default parameter values derived from the parent page.





Latest revision as of 16:52, 25 July 2023

Other languages:

Вставить группу проекций

Системное название
TechDraw_ProjectionGroup
Расположение в меню
TechDraw → Вставить группу проекций
Верстаки
TechDraw
Быстрые клавиши
Нет
Представлено в версии
-
См. также
Вставить Вид, Вставить Вид сечения

Описание

The TechDraw ProjectionGroup tool creates a multiview projection of one or more 3D objects. The isometric views of the 4 front corners can also be included.

If you only want to produce a single view, there is no advantage in using ProjectionGroup; you should then use Insert View instead. If you do not wish to use the traditional first- / third-angle projection, you should use multiple Views (Insert View) instead of ProjectionGroup.

Three orthogonal views and one isometric view of a solid object

Применение

  1. Optionally rotate the 3D view. The camera direction in the 3D view determines the initial value of the Primary Direction of the Projection Group (the ДанныеDirection property of the central view).
  2. Select one or more objects in the 3D view or Tree view.
  3. If there are multiple drawing pages in the document: optionally add the desired page to the selection by selecting it in the Tree view.
  4. There are several ways to invoke the tool:
    • Press the Insert Projection Group button.
    • Select the TechDraw → TechDraw Views → Insert Projection Group option from the menu.
  5. If there are multiple drawing pages in the document and you have not yet selected a page, the Page Chooser dialog box opens: introduced in version 0.20
    1. Select the desired page.
    2. Press the OK button.
  6. The Projection Group task panel opens.
  7. Select which views should appear in the Projection Group, and the Projection Group's scale and other parameters.
  8. Press the OK button.
  9. Optionally move the Projection Group by dragging its central view.
  10. Optionally move the Projection Group's other views relative to the central view by dragging them individually.

Projection Group task panel. The Primary Direction field indicates the current view direction.

Свойства

Data

Base

  • ДанныеSource (LinkList): Links to the drawable objects to be depicted.
  • ДанныеXSource (XLinkList): Links to the drawable objects in an external file.
  • ДанныеAnchor (Link): The central view in the group. Normally the Front view.
  • ДанныеProjectionType (Enumeration): First Angle or Third Angle.

For the other properties in this group see TechDraw View.

Collection

  • ДанныеViews (LinkList): Links to the views in this ProjectionGroup.

Distribute

  • ДанныеAuto Distribute (Bool): If true, space out individual views automatically. Use false to position manually.
  • Данныеspacing X (Length): Horizontal space between views when automatically positioned. Note that Scale and the size of other views in the group also influence the spacing.
  • Данныеspacing Y (Length): Vertical space between views when automatically positioned.

View

Base

See TechDraw View.

Notes

The ProjectionGroup as a whole inherits X, Y, ScaleType, Scale and Rotation from the basic View.

Individual Views within the group inherit all part view properties, but the ProjectionGroup object controls the scale of all its member Views.

The RotationVector property of individual Views within the group is deprecated as of v0.19. Use XDirection instead.

Note that the central box displays the current projection direction of the primary view. It cannot be used to change the direction.

Программирование

См. так же: TechDraw API и Основы составления скриптов FreeCAD.

A Projection Group can be created with macros and from the Python console by using the following functions:

import FreeCAD as App

doc = App.ActiveDocument
cyl = doc.addObject("Part::Cylinder", "Cylinder")
doc.recompute()

page = doc.addObject("TechDraw::DrawPage", "Page")
template = doc.addObject("TechDraw::DrawSVGTemplate", "Template")
template.Template = App.getResourceDir() + "Mod/TechDraw/Templates/A4_LandscapeTD.svg"
page.Template = template

# Toggle the visibility of the page to ensure its width and height are updated (hack):
page.Visibility = False
page.Visibility = True

group = doc.addObject("TechDraw::DrawProjGroup", "ProjGroup")
page.addView(group)
group.Source = [cyl]
group.ProjectionType = "Third Angle"

front_view = group.addProjection("Front") # First projection will become the Anchor.
group.Anchor.Direction = (0, 1, 0)
group.Anchor.RotationVector = (1, 0, 0)

left_view = group.addProjection("Left")
top_view = group.addProjection("Top")

group.X = page.PageWidth / 2
group.Y = page.PageHeight / 2

doc.recompute()

Note: The Projection Group should always be added to the Page, page.addView(group), before adding projections to the Group. This allows the Projection Group to use default parameter values derived from the parent page.